using Indotalent.Data.Entities;
using Indotalent.Shared.Consts;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Indotalent.Infrastructure.Database.MsSQL.Configuration;

public class ExpenseConfiguration : IEntityTypeConfiguration<Expense>
{
    public void Configure(EntityTypeBuilder<Expense> builder)
    {
        builder.Property(e => e.AutoNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Title)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Description)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.CampaignId)
            .HasMaxLength(GlobalConsts.StringLengthId);

        builder.HasOne(e => e.Campaign)
            .WithMany(e => e.ExpenseList)
            .HasForeignKey(e => e.CampaignId)
            .OnDelete(DeleteBehavior.NoAction);

        builder.HasIndex(e => e.AutoNumber).IsUnique();
        builder.HasIndex(e => e.ExpenseDate);
        builder.HasIndex(e => e.CampaignId);
    }
}